;; $Source: /usr/local/cvsroot/Mserver/rgexp/code/regreg-m1.scm,v $
;; Bigloo Module for NFA.scm
;;
;; $Log: regreg-m1.scm,v $
;; Revision 1.3  2002/09/27 01:54:59  latendre
;;
;;
;; Commit for export.
;;
;; Revision 1.2  2002/09/11 18:52:08  latendre
;;
;;
;; The main file name of the RegReg tool is now regreg.scm.
;;
;; Revision 1.1  2002/08/27 00:07:40  latendre
;;
;;
;; This is the first commit of the RegReg code into repository.
;;
;; Development code was in the parent directory. See attic for the
;; development versions and log information.
;;
;; Revision 1.2  2002/07/15 17:03:35  latendre
;;
;;
;; The three files `.reg' describe the three decoders for advisories.
;;
;; The file process-advisories.scm is the semantic processing and database
;; uploading code for advisories.
;;
;; Revision 1.1  2002/07/08 19:11:35  latendre
;;
;;
;; This is a stable version and a bigloo module to run the nfa generator.
;;

(module regreg
	(main start)
	(include "regreg.scm"))

(define (start argv)
  (let ((pfin  #f)
	(pfout #f)
	(print-fa? #f))

    (args-parse (cdr argv)
		(section "Help")
		(("?")	 (args-parse-usage #f))
		((("-h" "--help") (help "?,-h,--help" "This help message"))
		 (args-parse-usage #f))
		(section "Misc")
		((("-v" "--version") (help "Version number"))
		 (print "$Revision: 1.3 $ at $Date: 2002/09/27 01:54:59 $ by $Author: latendre $"))
		(("-o" ?file (help "The output file"))
		 (set! pfout file))
		(("--input=?file" (help "The input file"))
		 (set! pfin file))
		(("-print") (set! print-fa? #t))
		(section "File input")
		(else
		 (if pfin
		     (begin
		       (display-ln "You cannot specify several input files: " argv)
		       (exit))
		     (set! pfin (cadr argv)))))

    (if pfin
	(let* ((fin      (string-append pfin ".reg"))
	       (fout     (or pfout (string-append pfin ".scm"))))
	  (display-ln "Will read file "fin" and emit the output in file "fout) 
	  (regreg-file->scm fin fout print-fa?))
	(display-ln "No input file, exiting.")
	)))
