;; $Source: /usr/local/cvsroot/Mserver/rgexp/code/regreg-macros.scm,v $
;;
;; Mario Latendresse
;;
;; $Log: regreg-macros.scm,v $
;; Revision 1.2  2003/03/05 19:11:51  latendre
;; Added some error messages for macros.
;;
;; Revision 1.1  2003/01/22 19:07:39  latendre
;;
;;
;; This file contains useful macros to write concise code to manipulate
;; the tagged tree.
;;
;; $Id: regreg-macros.scm,v 1.2 2003/03/05 19:11:51 latendre Exp $

(define-macro (display-tags l)
  `(begin
     ,@(map (lambda (x) `(cerr "\n" ',x " " ,x))
	    l)))

;; A macro to bind variables with tagged subtrees from a structure and
;; execute a body.
;;
;; ltree and lstring are lists of symbols.
;; The ltree list creates a let where each symbol is bound to (gstree x struct)
;; The lstring list creates a let where each symbol is bound to (gstks x struct)
;;
;; Note: the body is a rest parm.
(define-macro (let-tags ltree lstring struct . body)
  (if (list-duplicate? ltree)
      (error "\nlet-tags, duplicate tag " (car (list-duplicate? ltree)))
      (if (list-duplicate? lstring)
	  (error "\nlet-tags, duplicate tag: " (car (list-duplicate? lstring)))
	  `(let ,(append (map (lambda (x) `(,x (gstree ',x ,struct))) ltree)
			 (map (lambda (x) 
				`(,(string->symbol
				    (string-append (symbol->string x) "-s")) 
				  (gstks ',x ,struct))) lstring))
	     ,@body))))
